% This is just a wrapper to the LDA of the Matlab Statistics Toolbox
classdef mania_lda < mania_classifier & mania_statisticsWrapper
    
    properties (Constant)
        availableTypes = { ... % 'linear', ...
            %'quadratic', ...
            'diagLinear', ...
            'diagQuadratic'}; %,  ...
        %'mahalanobis'};         % available discriminant functions
    end
    
    properties (SetAccess = protected)
        ldaParams = {'diagLinear'};              % default function
    end
    
    methods (Static)
        function shortName = name
            shortName = 'Linear Discriminant Analysis';
        end
    end
    
    methods
        
        function this = train(this,trainPatterns,trainLabels)
            % just regcognizes the patterns
            classifierStruct.trainPatterns = trainPatterns';
            classifierStruct.trainLabels = trainLabels';
            this.classifierStruct = classifierStruct;
        end
        
        function [predictions decFactors] = test(this,testPatterns)
            % predict, just calls classify
            predictions = classify(testPatterns', ...
                this.classifierStruct.trainPatterns,this.classifierStruct.trainLabels, this.ldaParams{:});
            % not implemented yet!
            decFactors = struct;
        end
        
        function this = setLDAparams(this, varargin)
            % Set additional Params of the Matlab Knn
            this.ldaParams = varargin;
        end
        
        function classifierStruct  = getClassifier(this,trainPatterns,trainLabels)
            classifierStruct.trainPatterns = trainPatterns;
            classifierStruct.trainLabels = trainLabels;
        end
        
        function jc = uiconfigure(jc)
            tIdx = listdlg('PromptString','Select Discriminant Function:','SelectionMode','single','ListString',jc.availableTypes);
            jc.ldaParams{1} = jc.availableTypes{tIdx};
        end
        
        function new = copy(this)
            new = copy@mania_classifier(this);
            new.ldaParams = this.ldaParams;
        end
        
        function show(jc)
            show@mania_classifier(jc);
            fprintf('Discriminant Function:        %s\n', jc.ldaParams{1});
        end
    end
    
    
end

