% Service Class, that handles request from features selection methods
% regarding the classCollection (which should be invisible for that
% methods).
%
% For instance request resizing a ROI
%
%
classdef mania_patternServiceMethods < handle
    
    
    properties (Access = private)
        classCollection;                    % actual classCollection
    end
    
    methods
        function this = mania_patternServiceMethods(classCollection)
            % contructor
            if ~isa(classCollection,'mania_classCollection')
                throw(MException('mania:WrongClass','This is not a classCollection-Class!'));
            else
                this.classCollection = classCollection;
            end
        end
        
        function dim = requestOrigDimension(this)
            % request original dimensions of images
            dim = this.classCollection.sourceDimension;
        end
        
        function ResizedImageLocation = requestImageResize(this,imageLocation)
            % request resizing a mask to the original data.
            ResizedImageLocation = resliceMask(this.classCollection.classes{1}.members{1}.imgFiles{1},imageLocation);
        end
        
    end
    
    
    
end