classdef mania_pre_randomMask < mania_pre_roi
    
    properties (SetAccess = protected)
        nFeatures;                       % how many random features
        randomStream;                    % random Stream for random values
    end
    
    methods (Static)
        function beVisbile = shouldBeVisible
            beVisbile = false;           % only for internal use for random subset methods (therefore not visible)
        end
    end
    
    methods
        function bool = isConfigurable(this)
            bool = true;
        end
        
        function patternOut = operate(this, patternIn, trainLabels)
            this.randomStream.reset;
            mask = zeros(size(patternIn,1),1);
            permIdx = randperm(this.randomStream,size(mask,1));
            randIdx = permIdx(1:this.nFeatures);
            mask(randIdx) = 1;
            this.mask = mask;
            patternOut = patternIn(logical(reshape(mask,numel(mask),1)),:);
        end
      
        function this = setRandomStream(this,s)
            % set a random Stream
            this.randomStream = s;
        end
        
        function this = reset(this)
            % reset randomStream (to reproduce same pseudo-random numbers
            % again)
            this.randomStream.reset;
        end
        
        function this = setNFeatures(this,nFeat)
            % set how many random features should be taken
            this.nFeatures = nFeat;
        end
        
        function new = copy(this)
            new = copy@mania_pre_roi(this);
            new.randomStream = this.randomStream;
            new.nFeatures = this.nFeatures;
        end
        
        function viewSettings(this)
            viewSettings@mania_pre_roi(this);
            fprintf('  Random Seed: %i\n',this.randomStream.Seed);
        end
        
    end
    
end