% Z-Scoring of patterns
classdef mania_pro_zscoring < mania_processor
    
    properties
        voxelmean;          % mean of voxels
        voxelstd;           % std deviation
    end
    
    methods (Static)
        function desc = description
            desc = 'Z-Scoring every voxel';
        end
        function shortName = name
            shortName = 'Z-Scoring';
        end
    end
    
    methods
        
        function [train, test] = operate(jpz,train, test,trainLabels)
            jpz.voxelmean = mean(train');
            jpz.voxelstd = std(train');
            train = bsxfun(@rdivide,(bsxfun(@minus,train',jpz.voxelmean)),jpz.voxelstd)';
            test = bsxfun(@rdivide,(bsxfun(@minus,test',jpz.voxelmean)),jpz.voxelstd)';
        end
        
        function patternRecon  = reconstruct(jpz,patternIn)
            % Do nothing - not necessary...
            patternRecon  = patternIn;
        end
        
        function patOut = reoperate(this,patternIn)
            error('not implemented');
        end
        
    end
    
    
end