% function to extract Map from weight vectors
%
% parser needed to recontsruct original image
function img = extractDiscriminativeMap (model, parser)

% scale values to 100 for better representation
scaleFactor = 100;

% case matlab SVM
if isfield(model,'SupportVectors')
    svecs = model.SupportVectors; 
    coeffs = model.Alpha; 
% case libsvm    
else
    svecs = model.SVs;
    coeffs = model.sv_coef;
end
res = zeros(1,size(svecs,2));
for k=1:size(svecs, 1)
    vec = svecs(k,:);
    res = res + vec * coeffs(k);
end
% recontruct image and scale
img = parser.reconstructFromProcessors(res);
img = img*scaleFactor/sum(max(abs(img(:))));