% apply threshold to image (percentage)
function imageThreshold

[filename, pathname, filterindex] = uigetfile('*.img', 'Pick an Image-File');
imgInfo = spm_vol([pathname filename]);
image = spm_read_vols(imgInfo);
imgPos = image;
imgNeg = image;
maxImg = max(max(max(image)));
minImg = min(min(min(image)));
   prompt={['Max: ' num2str(maxImg) ' - Min: ' num2str(minImg) ' +++ Percentage threshold (0 any, 100 only highest):']};
   name='Threshold an image';
   numlines=1;
   defaultanswer={'90'};
   answer=inputdlg(prompt,name,numlines,defaultanswer);
   answer=str2num(answer{:});

imgPos(imgPos<maxImg*answer/100) = 0;
imgNeg(imgNeg>minImg*answer/100) = 0;

V = imgInfo;
[ign pfname ext] = fileparts([pathname filename])
[file,path] = uiputfile([pfname '_T' num2str(answer) '.img'], 'Save thresholded image');
V.fname = [path file];
spm_write_vol(V,imgPos+imgNeg);
